/**
 * {面包屑导航}
 * @author yutent<yutent.io@gmail.com>
 * @date 2023/04/10 16:12:33
 */

import { css, html, Component, styleMap } from 'wkit'

class Breadcrumb extends Component {
  static styles = [
    css`
      :host {
        display: flex;
        align-items: center;
        width: 100%;
        height: 32px;
        font-size: 14px;
      }
    `
  ]

  #updateChildrenStat(checkAll) {
    let list = Array.from(this.children)
    list.forEach((it, i) => {
      if (it.tagName === 'WC-BREADCRUMB-ITEM') {
        it.last = list.length === i + 1
      } else {
        it.remove()
      }
    })
  }

  mounted() {
    this.#updateChildrenStat()
  }
}

class Item extends Component {
  static props = {
    separator: '/',
    last: 'bool!'
  }

  static styles = [
    css`
      :host,
      .item {
        display: inline-flex;
        align-items: center;
        height: 32px;
        font-size: 14px;
      }
      .pipe {
        margin: 0 8px;
        user-select: none;
      }
    `
  ]

  render() {
    return html`
      <label class="item">
        <slot></slot>
        <span
          class="pipe"
          style=${styleMap({ display: this.last ? 'none' : '' })}
        >
          <slot name="separator">${this.separator || '/'}</slot>
        </span>
      </label>
    `
  }
}

Breadcrumb.reg('breadcrumb')
Item.reg('breadcrumb-item')
